//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#include "stdafx.h"
#include "emule.h"
#include "Statistics.h"
#include "UploadQueue.h"
#include "Preferences.h"
#include "BandWidthControl.h" // [TPT]

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
extern _CRT_ALLOC_HOOK g_pfnPrevCrtAllocHook;
#endif


CStatistics::CStatistics()
{
	// [TPT]
	//maxDown=0;
	//maxDownavg=0;
	maxcumDown =			thePrefs.GetConnMaxDownRate();
	cumUpavg =				thePrefs.GetConnAvgUpRate();
	maxcumDownavg =			thePrefs.GetConnMaxAvgDownRate();
	cumDownavg =			thePrefs.GetConnAvgDownRate();
	maxcumUpavg =			thePrefs.GetConnMaxAvgUpRate();
	maxcumUp =				thePrefs.GetConnMaxUpRate();
	//maxUp =					0;
	//maxUpavg =				0;
	//rateDown =				0;
	//rateUp =				0;
	timeTransfers =			0;
	timeDownloads =			0;
	timeUploads =			0;
	start_timeTransfers =	0;
	start_timeDownloads =	0;
	start_timeUploads =		0;
	time_thisTransfer =		0;
	time_thisDownload =		0;
	time_thisUpload =		0;
	timeServerDuration =	0;
	time_thisServerDuration=0;

	// [TPT] - Maella Bandwidth
	currentUploadRate = 0;
	currentMaxUploadRate = 0;
	sessionUploadRate = 0;
	sessionMaxUploadRate = 0;

	currentDownloadRate = 0;
	currentMaxDownloadRate = 0;
	sessionDownloadRate = 0;
	sessionMaxDownloadRate = 0;
}

CStatistics::~CStatistics()
{
}


// -khaos--+++> This function is going to basically calculate and save a bunch of averages.
//				I made a seperate funtion so that it would always run instead of having
//				the averages not be calculated if the graphs are disabled (Which is bad!).
void CStatistics::UpdateConnectionStats(void){
	
	// Wait at least 5 seconds
	if(::GetTickCount() - theApp.pBandWidthControl->GetStartTick() + 5000){

		// Maella -Graph: code Improvement for rate display-
		uint32 plotOutData[ADAPTER+1];
		uint32 plotinData[ADAPTER+1];
		theApp.pBandWidthControl->GetDatarates(1,
											plotinData[CURRENT], plotinData[OVERALL],
											plotOutData[CURRENT], plotOutData[OVERALL],
											plotinData[ADAPTER], plotOutData[ADAPTER]);

		theApp.pBandWidthControl->GetFullHistoryDatarates(plotinData[MINUTE], plotOutData[MINUTE],
														  plotinData[SESSION], plotOutData[SESSION]);

		currentDownloadRate = (float)plotinData[CURRENT]/1024.0;
		sessionDownloadRate = (float)plotinData[SESSION]/1024.0;
		currentUploadRate   = (float)plotOutData[CURRENT]/1024.0;
		sessionUploadRate   = (float)plotOutData[SESSION]/1024.0;
		// Maella end

		// Max Current rates (graph refresh)
		if(currentMaxUploadRate < currentUploadRate) 
			currentMaxUploadRate = currentUploadRate;
		if(currentMaxDownloadRate < currentDownloadRate) 
			currentMaxDownloadRate = currentDownloadRate;

		// Session Max rates
		if(sessionMaxUploadRate < sessionUploadRate) 
			sessionMaxUploadRate = sessionUploadRate;
		if(sessionMaxDownloadRate < sessionDownloadRate) 
			sessionMaxDownloadRate = sessionDownloadRate;

		// Cumulative Max Current rates (graph refresh)
		if(maxcumUp < currentMaxUploadRate) {
			maxcumUp = currentMaxUploadRate;
		thePrefs.Add2ConnMaxUpRate(maxcumUp);
	}
		if(maxcumDown < currentMaxDownloadRate) {
			maxcumDown = currentMaxDownloadRate;
		thePrefs.Add2ConnMaxDownRate(maxcumDown);
	}

		// Cumulative Max Average rates
		cumDownavg = (sessionDownloadRate + thePrefs.GetConnAvgDownRate()) / 2;
		cumUpavg = (sessionUploadRate + thePrefs.GetConnAvgUpRate()) / 2;
		if(maxcumDownavg < cumDownavg) {
			maxcumDownavg = cumDownavg;
		thePrefs.Add2ConnMaxAvgDownRate(maxcumDownavg);
	}
		if(maxcumUpavg < cumUpavg) {
			maxcumUpavg = cumUpavg;
		thePrefs.Add2ConnMaxAvgUpRate(maxcumUpavg);
	}
	
	// Transfer Times (Increment Session)
		if (sessionUploadRate > 0.0f || sessionDownloadRate > 0.0f) {
		if (start_timeTransfers == 0) start_timeTransfers = GetTickCount();
		else time_thisTransfer = (GetTickCount() - start_timeTransfers) / 1000;

			if (sessionUploadRate > 0.0f) {
			if (start_timeUploads == 0) start_timeUploads = GetTickCount();
			else time_thisUpload = (GetTickCount() - start_timeUploads) / 1000;
		}

			if (sessionDownloadRate > 0.0f) {
			if (start_timeDownloads == 0) start_timeDownloads = GetTickCount();
			else time_thisDownload = (GetTickCount() - start_timeDownloads) / 1000;
		}
	}

		if (sessionUploadRate == 0.0f && sessionDownloadRate == 0.0f && (time_thisTransfer > 0 || start_timeTransfers > 0)) {
		timeTransfers += time_thisTransfer;
		time_thisTransfer = 0;
		start_timeTransfers = 0;
	}

		if (sessionUploadRate == 0.0f && (time_thisUpload > 0 || start_timeUploads > 0)) {
		timeUploads += time_thisUpload;
		time_thisUpload = 0;
		start_timeUploads = 0;
	}

		if (sessionDownloadRate == 0.0f && (time_thisDownload > 0 || start_timeDownloads > 0)) {
		timeDownloads += time_thisDownload;
		time_thisDownload = 0;
		start_timeDownloads = 0;
	}

	// Server Durations
	if (theApp.stat_serverConnectTime==0) theApp.statistics->time_thisServerDuration = 0;
	else time_thisServerDuration = ( GetTickCount() - theApp.stat_serverConnectTime ) / 1000;
	}
}
// <-----khaos-


